class RLista {
  private Object cap;
  private RLista coada;

  public Object cap() {
    return cap;
  }

  public RLista coada() {
    return coada;
  }

  /* Verifica daca obj exista in lista */
  public boolean contine(Object obj) {
    if(obj==cap) return true;
    if(obj.equals(cap)) return true;
    if(coada==null) return false;
    return coada.contine(obj);
  }

  /* Intoarce o lista noua, provenita din concatenarea acestei liste
     cu lista1
  */
  public RLista concat(RLista lista1) {
    if(cap==null && coada==null) return lista1;
    RLista listaNoua=(RLista)clone();
    RLista cd=listaNoua.coada;
    while(cd.coada!=null) cd=cd.coada;
    cd.coada=(RLista)lista1.clone();
    return listaNoua;
  }

  /* Pune obiectul obj in capul acestei liste (lungeste lista)*/
  public void puneCap(Object obj) {
    RLista listaVeche=new RLista();
    listaVeche.cap=cap;
    listaVeche.coada=coada;
    cap=obj;
    coada=listaVeche;
  }

  /* Inlocuieste obiectul din capul listei cu obj */
  public Object inlocuiesteCap(Object obj) {
    Object capVechi=cap;
    cap=obj;
    return capVechi;
  }

  /* Elimina capul listei (scurteaza astfel lista) */
  public Object eliminaCap() {
    Object capVechi=cap;
    if(coada==null) cap=null;
    else {
      cap=coada.cap;
      coada=coada.coada;
    }
    return capVechi;
  }   
    
  /* Converteste lista in sir (redefinirea metodei toString()
     din clasa Object
  */
  public String toString() {
    StringBuffer b=new StringBuffer("[");
    if(cap != null) b.append(cap.toString());
    RLista cd=coada;
    while(cd!=null) {
      if(cd.cap != null) b.append(", "+cd.cap.toString());
      cd=cd.coada;
    }
    b.append("]");
    return b.toString();
  }

  /* Intoarce o clona a acestei liste (redefinirea metodei clone()
     din clasa Object
  */
  public Object clone() {
    RLista listaNoua=new RLista();
    listaNoua.cap=cap;
    if(coada==null) listaNoua.coada=null;
    else listaNoua.coada=(RLista)coada.clone();
    return listaNoua;
  }
}

/* Aplicatie de testare a clasei RList */
class TestRLista {
  public static void main(String args[]) {
    RLista lista=new RLista();
    System.out.println("S-a creat lista "+lista);
    String[] ts={"A", "B", "C", "D"};
    for (int i=0; i<ts.length; i++) lista.puneCap(ts[i]);
    System.out.println("Dupa adaugari "+lista);
    RLista oClona=(RLista)lista.clone();
    System.out.println("Clona listei "+oClona);
    RLista altaLista=new RLista();
    String[] ts1={"X", "Y", "Z"};
    for (int i=0; i<ts1.length; i++) altaLista.puneCap(ts1[i]);
    RLista lista1=lista.concat(altaLista);
    System.out.println("Dupa concatenare "+lista1);
    System.out.println("Contine Y: "+lista1.contine("Y")+
        "   Contine W: "+lista1.contine("W"));
    lista1.inlocuiesteCap("WW");
    System.out.println("Inlocuire cap: "+lista1);
    lista1.eliminaCap();
    System.out.println("Eliminare cap: "+lista1);
  }
}
