public class ArboreCautare {
  Nod radacina;
  
  /* Constructori si metode */
  public ArboreCautare() {
    radacina=null;
  }

  /* Se testeaza existenta in arbore a valorii val */
  private static boolean exista(Object val, Nod nod) {
    if(nod==null) return false;
    int rez=((Comparable)val).compareTo(nod.info);
    if(rez==0) return true;
    if(rez<0) return exista(val, nod.fiuStanga);
    return exista(val, nod.fiuDreapta);
  }

  public boolean exista(Object val) {
    return exista(val, radacina);
  }

  /* Se intoarce nodul in care se gaseste valoarea val */
  private Nod cauta(Object val, Nod nod) {
    if(nod==null) return null;
    int rez=((Comparable)val).compareTo(nod.info);
    if(rez==0) return nod;
    if(rez<0) return cauta(val, nod.fiuStanga);
    return cauta(val, nod.fiuDreapta);
  }

  public Nod cauta(Object val) {
    return cauta(val, radacina);
  }

  private boolean pune(Object val, Nod nod) {
    int i=((Comparable)val).compareTo(nod.info);
    if(i==0) return false; // val deja exista, nu se mai pune
    if(i<0) {
      if(nod.fiuStanga==null) {
        nod.fiuStanga=new Nod(val);
        return true;
      }
      else return pune(val, nod.fiuStanga);
    }
    else if(nod.fiuDreapta==null) {
           nod.fiuDreapta=new Nod(val);
           return true;
         }
    return pune(val, nod.fiuDreapta);
  }

  public boolean pune(Object val) {
    if(radacina==null) {
      radacina=new Nod(val);
      return true;
    }
    return pune(val, radacina);
  }

  private Nod minim(Nod nod) {
    if(nod.fiuStanga==null) return nod;
    return minim(nod.fiuStanga);
  }

  public Object minim() {
    if(radacina==null) return null;
    return minim(radacina).info;
  }

  private Nod maxim(Nod nod) {
    if(nod.fiuDreapta==null) return nod;
    return maxim(nod.fiuDreapta);
  }

  public Object maxim() {
    if(radacina==null) return null;
    return maxim(radacina).info;
  }


  /* Metoda auxiliara recursiva care converteste un subarbore intr-un
     sir, in care arborele este pus in formatul cu paranteze
  */
  private StringBuffer toStringBuffer(StringBuffer sb, Nod nod) {
    sb.append("("+nod.info);
    if(nod.fiuStanga!=null) toStringBuffer(sb, nod.fiuStanga);
    else if(nod.fiuDreapta!=null) sb.append("(()");
    if(nod.fiuDreapta!=null) toStringBuffer(sb, nod.fiuDreapta);
    else if(nod.fiuStanga!=null) sb.append("()");
    sb.append(")");
    return sb;
  }

  /* Redefinirea metodei toString din clasa Object. Foloseste metoda
     auxiliara toStringBuffer() aplicata radacinii arborelui
  */
  public String toString() {
    StringBuffer sb=new StringBuffer();
    if(radacina==null) return "( )";
    return toStringBuffer(sb, radacina).toString();
  }

    
    
  /* CLASE INTERIOARE */
  /* Nod al arborelui de cautare */
  class Nod {
    Object info;
    Nod fiuStanga, fiuDreapta;

    Nod(Object obj) {
      info=obj;
      fiuStanga=fiuDreapta=null;
    }

    public String toString() {
      return "["+info+"]";
    }
  }
}

