import java.util.*;

public class GrafLA {
  protected ArrayList varfuri;

  public GrafLA() {
    varfuri=new ArrayList();
  }

  public boolean puneVarf(String eticheta) {
    if(eticheta==null) return false;
    Varf v=new Varf(eticheta);
    if(varfuri.contains(v)) return false;
    varfuri.add(v);
    return true;
  }

  public boolean puneVarf(String eticheta, Object info) {
    if(eticheta==null) return false;
    Varf v=new Varf(eticheta, info);
    if(varfuri.contains(v)) return false;
    varfuri.add(v);
    return true;
  }

  public boolean puneArc(String baza, String varf) {
    if(baza==null || varf==null) return false;
    Varf v=null, vb=null, vv=null;
    boolean gasitb=false, gasitv=false;
    int nrVarfuri=varfuri.size();
    for(int i=0; (!gasitb || !gasitv) && i<nrVarfuri; i++) {
      v=(Varf)varfuri.get(i);
      if(v.eticheta.equals(baza)){
        vb=v;
        gasitb=true;
      }
      if(v.eticheta.equals(varf)){
        vv=v;
        gasitv=true;
      }
    }
    if(!gasitb || !gasitv) return false;
    if(vb.adiacente.contains(vv)) return false;
    vb.adiacente.add(vv);
    return true;
  }

  public boolean eliminaArc(String baza, String varf) {
    if(baza==null || varf==null) return false;
    Varf v=null, vb=null, vv=null;
    boolean gasitb=false, gasitv=false;
    int nrVarfuri=varfuri.size();
    for(int i=0; (!gasitb || !gasitv) && i<nrVarfuri; i++) {
      v=(Varf)varfuri.get(i);
      if(v.eticheta.equals(baza)){
        vb=v;
        gasitb=true;
      }
      if(v.eticheta.equals(varf)){
        vv=v;
        gasitv=true;
      }
    }
    if(!gasitb || !gasitv) return false;
    int index=vb.adiacente.indexOf(vv);
    if(index<0) return false;
    vb.adiacente.remove(index);
    return true;
  }

  public boolean eliminaVarf(String varf) {
    if(varf==null) return false;
    // Se cauta varful cu eticheta varf
    Varf v=null, vv=null;
    boolean gasitv=false;
    int nrVarfuri=varfuri.size(), indice1=-1, indice2=-1;
    for(int i=0; !gasitv && i<nrVarfuri; i++) {
      v=(Varf)varfuri.get(i);
      if(v.eticheta.equals(varf)){
        vv=v;
        indice1=i;
        gasitv=true;
      }
    }
    if(!gasitv) return false;
    // Se elimina varful din listele de adiacenta ale celorlalte
    Iterator iter=varfuri.iterator();
    while(iter.hasNext()) {
      v=(Varf)iter.next();
      indice2=v.adiacente.indexOf(vv);
      if(indice2>=0) v.adiacente.remove(indice2);
    }
    // Se elimina varf din lista de varfuri
    varfuri.remove(indice1); 
    //int index=vb.adiacente.indexOf(vv);
    //if(index<0) return false;
    //vb.adiacente.remove(index);

    return true;
  }

  public String toString() {
    StringBuffer buffer=new StringBuffer();
    Varf v;
    buffer.append("{");
    Iterator iter=varfuri.iterator();
    while(iter.hasNext()) {
      v=(Varf)iter.next();
      buffer.append("("+v.eticheta+v.adiacente+")");
    }
    buffer.append("}");
    return buffer.toString();
  } 

  class Varf {
    String eticheta;
    Object info;
    ArrayList adiacente;
  
    Varf(String eticheta) {
      this.eticheta=eticheta;
      info=null;
      adiacente=new ArrayList();
    }

    Varf(String eticheta, Object info) {
      this.eticheta=eticheta;
      this.info=info;
      adiacente=new ArrayList();
    }

    public boolean equals(Object obj) {
      if(eticheta.equals(((Varf)obj).eticheta)) return true;
      return false;
    }

    public String toString() {
      return "("+eticheta+")";
    }
  }
}
