/* Clasa care genereaza succesiv elementele unui produs cartezian
*/

import java.util.ArrayList;

public class ProdusCartezian extends Backtracking {
  Object[][] multimi; // Fiecare linie contine elementele unei multimi

  /* Constructorul primeste ca parametri tabloul in care fiecare
     linie contine elementele unei multimi de obiecte. Liniile pot
     avea lungimi diferite, deci multimile au cardinale diferite
  */
  public ProdusCartezian(Object[][] tablouMultimi) {
    multimi=tablouMultimi;
    ElemStiva elementGarda=new ElemStiva(null);
    stiva.add(elementGarda);
  }

  /* Este solutie orice tuplu care contine cate un element din fiecare
     linie a tabloului. Elementele luate in consideratie incep de la
     indicele 1 din stiva, deoarece primul (de indice 0) este
     elementul de garda
  */
  protected Object solutie() {
    if(stiva.size()<(multimi.length+1)) return null;
    ArrayList solutie=new ArrayList();
    for(int j=1; j<stiva.size(); j++) {
      ElemStiva elementCurent=(ElemStiva)stiva.get(j);
      int indice=((Integer)elementCurent.element).intValue();
      solutie.add(multimi[j-1][indice]);
    }
    return solutie;
  }

  /* Succesor al obiectului din varful stivei poate fi orice obiect
     din linia corespunzatoare a tabloului multimi. Se ia cel care 
     urmeaza dupa ultimul folosit
  */
  protected Object succesor() {
    if(multimi.length==0) return null;
    if(stiva.isEmpty() || stiva.size()==(multimi.length+1))
           return null;
    int i,j;
    i=stiva.size()-2; // indicile liniei din tabloul multimi
    ElemStiva varfStiva=(ElemStiva)stiva.get(i+1);
    if(varfStiva.ultimSuccesorVizitat==null) return new Integer(0);
    j=((Integer)varfStiva.ultimSuccesorVizitat).intValue();
    if(j>=multimi[i+1].length-1) return null;
    return new Integer(j+1);
  }

  protected boolean esteValid(Object succesor) {
    /* Orice succesor este valid */
    return true;
  }
}
    