/* Construieste arborele de acoperire de cost minim al unui graf prin metoda Greedy.
   Graful este dat ca o lista de muchii, pentru fiecare muchie fiind indicat
   si costul parcurgerii  ei.
*/ 

import java.util.*;

class ArbAcopCM extends Greedy {
  ArrayList graf=new ArrayList();
  int numarArbori, numarMuchii, numarNoduriGraf;
  Set multimeNoduri; 

  public ArbAcopCM(List muchiiGraf) {
    super(muchiiGraf);
    numarArbori=numarMuchii=0;
    /* Se construieste multimea nodurilor grafului, pentru a putea determina
       numarul de noduri 
    */
    Muchie m;
    Iterator iter=muchiiGraf.iterator();
    multimeNoduri=new HashSet();
    while(iter.hasNext()) {
      m=(Muchie)iter.next();
      multimeNoduri.add(m.nod1);
      multimeNoduri.add(m.nod2);
    }
    numarNoduriGraf=multimeNoduri.size();
    multimeNoduri=null; // multimea nodurilor nu mai este necesara
  }

  public Object selectie() {
    return Collections.min(c);
  }

  public boolean poateFiAdaugat(Collection s, Object x) {
    Muchie m=(Muchie)x;
    int arb1=0, arb2=0;
    Iterator iter=s.iterator();
    // se cauta la ce arbori apartin m.nod1 si m.nod2
    Muchie mc;
    while(iter.hasNext()) {
      mc=(Muchie)iter.next();
      if(m.nod1.equals(mc.nod1) || m.nod1.equals(mc.nod2)) arb1=mc.nrArbore;
      if(m.nod2.equals(mc.nod1) || m.nod2.equals(mc.nod2)) arb2=mc.nrArbore;
    }

    /* Daca ambele noduri ale muchiei apartin aceluiasi arbore, nu se poate
       adauga, deoarece formeaza un circuit
    */
    if(arb1==arb2 && arb1!=0) return false;
    /* Muchia selectata se poate adauga la arbore, dar trebuie stabilit 
       in ce mod
    */

    if(arb1==0 && arb2==0) { // se creeaza un nou arbore
      numarArbori++;
      m.nrArbore=numarArbori;
    }
    else if(arb1==0) { // se ataseaza cu nodul nod2 la arb2
      m.nrArbore=arb2;
    }
    else if(arb2==0) { // se ataseaza cu nodul nod1 la arb1
      m.nrArbore=arb1;
    }
    else {
      /* Fiecare nod al muchiei x apartine altui arbore. Se unesc cei doi arbori,
         dandu-le cel mai mic din cele doua numere
      */
      int nrNou= arb1<arb2?arb1:arb2;
      m.nrArbore=nrNou;
      iter=s.iterator();
      while(iter.hasNext()) { // se face renumerotarea arborilor
        mc=(Muchie)iter.next();
        if((mc.nrArbore==arb1 || mc.nrArbore==arb2)&&mc.nrArbore!=nrNou)
           mc.nrArbore=nrNou;
      }
    }
    /* In toate aceste cazuri s-a mai adaugat o muchie */
    numarMuchii++;
    if(numarMuchii>=(numarNoduriGraf-1)) gasitSolutia=true;
    return true;
  }

  /* Clasa imbricata a muchiilor grafului */
  static class Muchie implements Comparable {
    String nod1, nod2;
    double cost;
    int nrArbore;

    public Muchie(String nod1, String nod2, double cost) {
      this.nod1=nod1;
      this.nod2=nod2;
      this.cost=cost;
      nrArbore=0;
    }

    public String toString() {
      return "("+nod1+"-"+nod2+": cost="+cost+")";
    }

    public int compareTo(Object ob) {
      double dif=cost-((Muchie)ob).cost;
      if (dif<0) return -1;
      if (dif>0) return 1;
      return 0;
    }
  }
}