import java.util.*;

public class Dijkstra {
  private static LinkedList graf, arbore, coada;

  public static Collection dijkstra(Collection muchiiGraf, String nodSursa) {
    /* initializari */
    graf=new LinkedList(muchiiGraf);
    arbore=new LinkedList();
    coada=new LinkedList();
    coada.add(new NodArbore(null, nodSursa, 0));
    
    /* Incepe bucla Greedy */
    NodArbore nodExtras;
    while(!coada.isEmpty()) {
      nodExtras=(NodArbore)coada.removeFirst();
      arbore.addLast(nodExtras);
      relaxeaza(nodExtras);
    } // sfarsit bucla Greedy

    return arbore;
  }

  private static void relaxeaza(NodArbore nodExtras) {
    /* Se extrag din graf muchiile care au la unul din capete nodul final din nodExtras.
       Acest nod devine tata, iar celalalt nod al muchiei grafului devine fiu
    */
    Muchie muchieCurenta;
    String tata, fiu;
    tata=nodExtras.nodCurent;
    ListIterator iter=graf.listIterator();
    while(iter.hasNext()) {
      muchieCurenta=(Muchie)iter.next();
      fiu=null;
      if(muchieCurenta.nod1.equals(tata)) fiu=muchieCurenta.nod2;
      else if(muchieCurenta.nod2.equals(tata)) fiu=muchieCurenta.nod1;
      if(fiu!=null) { // muchia curenta este adiacenta la "tata"
        iter.remove(); // se  elimina muchia curenta din graf
        if(!esteInArbore(fiu)) puneInCoada(new NodArbore(tata, fiu,  
                     nodExtras.distantaSursa+muchieCurenta.lungime));
      } // sfarsit if pentru muchii adiacente la tata
    } // sfarsit extragere muchii din graf
  }

  private static boolean esteInArbore(String fiu) {
    ListIterator iter=arbore.listIterator();
    boolean gasit=false;
    while(!gasit && iter.hasNext())
      if(((NodArbore)iter.next()).nodCurent.equals(fiu)) gasit=true;
    return gasit;
  }

  private static void puneInCoada(NodArbore nodAdaugat) {
    /* Se cauta in coada nodAdaugat */
    ListIterator iter=coada.listIterator();
    NodArbore arcCoada=null;
    boolean gasit=false, trebuieAdaugat=true;
    while(!gasit && iter.hasNext()) {
      arcCoada=(NodArbore)iter.next();
      if(arcCoada.nodCurent.equals(nodAdaugat.nodCurent)) {
        gasit=true;
        if(nodAdaugat.distantaSursa<arcCoada.distantaSursa)
          iter.remove(); // se scoate nodul vechi si se adauga cel nou
        else trebuieAdaugat=false;
      } // sfarsit if
    } // Sfarsit while cautare in coada
    /* daca este necesar, se adauga nodul nou in coada, pe pozitia corespunzatoare
       distantei sale la sursa
    */
    if(trebuieAdaugat) {
      if(coada.isEmpty()) coada.add(nodAdaugat);
      else {
        /* Se cauta in coada pozitia pe care elementul trebuie inserat */
        int indice=-1;
        iter=coada.listIterator();
        gasit=false;
        while(!gasit && iter.hasNext()) {
          indice++;
          arcCoada=(NodArbore)iter.next();
          if(arcCoada.distantaSursa>nodAdaugat.distantaSursa) gasit=true;
        }  // Sfarsit while cautare pozitie pentru inserare
        /* Se face inserarea noului element */
        if(!gasit) coada.addLast(nodAdaugat);
        else coada.add(indice, nodAdaugat);
      } // Sfarsit else
    } // sfarsit if(trebuieAdaugat)
  }  

  static class Muchie {
    String nod1, nod2;
    double lungime;

    public Muchie(String nod1, String nod2, double lungime) {
      this.nod1=nod1;
      this.nod2=nod2;
      this.lungime=lungime;
    }

    public String toString() {
      return "("+nod1+"-"+nod2+": "+lungime+")";
    }
  }

  static class NodArbore {
    String tata, nodCurent;
    double distantaSursa;

    NodArbore(String tata, String nodCurent, double distantaSursa) {
      this.tata=tata;
      this.nodCurent=nodCurent;
      this.distantaSursa=distantaSursa;
    }

    public String toString() {
      return "("+tata+" - "+nodCurent+": "+distantaSursa+")";
    }
  }
}