/* Se rezolva problema rucsacului prin metoda Greedy
*/

import java.util.*;

public class Rucsac extends Greedy {
  double greutateMax, greutateContinut;

  Rucsac(Collection necesar, double greutateMaxima) {
    super(new ArrayList(necesar));
    greutateMax=greutateMaxima;
  }

  public Object selectie() {
    return Collections.max(c);
  }

  /* Un nou obiect poate fi pus in rucsac numai daca prin aceasta 
     nu se depaseste greutatea maxima a rucsacului
  */
  public boolean poateFiAdaugat(Collection s, Object x) {
    ProdusNecesar prn=(ProdusNecesar)x;
    if((greutateContinut+prn.greutateDisponibila)<=greutateMax) {
      /* se pune in rucsac intreaga cantitate disponibila din produsul curent */
      prn.cantitate=prn.greutateDisponibila;
      greutateContinut+=prn.cantitate;
    }
    else {
      /* se pune in rucsac din produsul curent numai diferenta dintre
         greutatea maxima admisa si greutatea produselor puse anterior 
         si se incheie punerea de produse in rucsac
      */
      prn.cantitate=greutateMax-greutateContinut;
      greutateContinut+=greutateMax;
      gasitSolutia=true;
    }
    return true;
  }

  /* Clasa imbricata a produselor necesare  */
  public static class ProdusNecesar implements Comparable {
    double pretUnitar;
    double greutateDisponibila;
    double cantitate;

    /* Produsele necesare se compara dupa pretul pe unitatea de greutate */
    public int compareTo(Object ob) {
      double diferentaPret=pretUnitar-((ProdusNecesar)ob).pretUnitar;
      if(diferentaPret<0) return -1;
      if(diferentaPret>0) return 1;
      return 0;
    }

    public String toString() {
      return "(pr="+pretUnitar+" grd="+greutateDisponibila+" cant="+cantitate+")";
    }
  }
}